package techreborn.init;

import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonObject;
import com.mojang.datafixers.Dynamic;
import com.mojang.datafixers.types.JsonOps;
import org.apache.commons.io.FileUtils;
import org.apache.commons.lang3.Validate;
import techreborn.items.ItemDynamicCell;

import java.io.File;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.*;
import java.util.function.Function;
import java.util.stream.Collectors;
import net.minecraft.class_1657;
import net.minecraft.class_1703;
import net.minecraft.class_1715;
import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_2378;
import net.minecraft.class_2509;
import net.minecraft.class_2585;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_3611;
import net.minecraft.class_3612;
import net.minecraft.class_3955;
import net.minecraft.class_3956;

public class RecipeTemplate {

	public static void generateFromInv(class_1657 playerEntity) throws IOException {

		if(playerEntity.field_7514.method_5438(0).method_7960()){
			playerEntity.method_9203(new class_2585("no machine in first slot"));
			auto(playerEntity);
			return;
		}

		List<class_1799> inputs = new ArrayList<>();
		List<class_1799> outputs = new ArrayList<>();
		class_2960 type = class_2378.field_11142.method_10221(playerEntity.field_7514.method_5438(0).method_7909());

		for (int i = 1; i < playerEntity.field_7514.method_5439(); i++) {
			class_1799 stack = playerEntity.field_7514.method_5438(i);
			if(!stack.method_7960()){
				if(i < 9){
					outputs.add(stack);
				} else {
					inputs.add(stack);
				}
			}
		}

		File file = generate(type,false, 20, 400, inputs, outputs);

		playerEntity.method_9203(new class_2585("done: " + file.getAbsolutePath()));

	}

	public static void auto(class_1657 playerEntity) throws IOException {
		List<class_1792> items = class_2378.field_11142.method_10220().collect(Collectors.toList());


		Map<String, Map<String, class_1792>> map = new HashMap<>();
		List<String> names = new ArrayList<>();


		for(class_1792 item : items){
			class_2960 identifier = class_2378.field_11142.method_10221(item);
			String path = identifier.method_12832();

			if(path.contains("_")){
				String name = path.substring(0, path.lastIndexOf('_')).replace("_storage", "");
				String type = path.substring(path.lastIndexOf('_') + 1);

				Map<String, class_1792> typeMap = map.computeIfAbsent(type, s -> new HashMap<>());

				typeMap.put(name, item);

				if (!names.contains(name)) {
					names.add(name);
				}
			}

		}

		boolean compressor = false;
		boolean grinder = false;
		boolean sawmill = false;

		if(compressor){
			//Compressor
			for(String name : names){
				class_1799 plateStack = class_1799.field_8037;
				if(map.get("plate").containsKey(name)){
					class_1792 plate = map.get("plate").get(name);
					plateStack = new class_1799(plate);
				}

				if(plateStack.method_7960()){
					continue;
				}

				if(map.get("ingot").containsKey(name)){
					class_1799 ingotStack = new class_1799(map.get("ingot").get(name));
					generate(new class_2960("techreborn", "compressor"), true, 10, 300,  Collections.singletonList(ingotStack), Collections.singletonList(plateStack));
				}

				if(map.get("dust").containsKey(name)){
					class_1799 dust = new class_1799(map.get("dust").get(name));
					generate(new class_2960("techreborn", "compressor"), true, 10, 250,  Collections.singletonList(dust), Collections.singletonList(plateStack));
				}

				if(map.get("block").containsKey(name)){
					class_1799 blockStack = new class_1799(map.get("block").get(name));

					class_1799 morePlates = plateStack.method_7972();
					morePlates.method_7939(9);

					generate(new class_2960("techreborn", "compressor"), true, 10, 300,  Collections.singletonList(blockStack), Collections.singletonList(morePlates));
				}
			}
		}

		if(grinder){
			String[] highTeirNames = new String[]{"tungsten", "titanium", "aluminium", "iridium", "saltpeter", "coal", "diamond", "emerald", "redstone", "quartz"};

			String[] types = new String[]{"ore", "gem", "ingot"};

			//Grinder
			for(String name : names){
				for(String type : types){
					class_1799 inputStack = class_1799.field_8037;
					if(map.get(type).containsKey(name)){
						class_1792 ore = map.get(type).get(name);
						inputStack = new class_1799(ore);
					}

					if(inputStack.method_7960()){
						continue;
					}

					boolean ore = type.equals("ore");

					if (ore && Arrays.asList(highTeirNames).contains(name)) {
						continue;
					}

					class_1799 dustStack = class_1799.field_8037;
					if(map.get("dust").containsKey(name)){
						class_1792 dust = map.get("dust").get(name);
						dustStack = new class_1799(dust);
					}

					if(dustStack.method_7960()){
						continue;
					}

					if (ore){
						dustStack.method_7939(2);
					}

					generate(new class_2960("techreborn", "grinder"), true, ore ? 270 : 200, ore ? 31 : 22, Collections.singletonList(inputStack), Collections.singletonList(dustStack));
				}

			}
		}

		if(sawmill){

			class_1715 inventory = new class_1715(new class_1703(null, 0) {
				@Override
				public boolean method_7597(class_1657 var1) {
					return true;
				}
			}, 1, 1);

			for(String name : names){
				class_1799 inputStack = class_1799.field_8037;
				if(map.get("log").containsKey(name)){
					class_1792 ore = map.get("log").get(name);
					inputStack = new class_1799(ore);
				}

				if(inputStack.method_7960()){
					continue;
				}

				inventory.method_5447(0, inputStack.method_7972());

				List<class_3955> recipes = playerEntity.field_6002.method_8433().method_17877(class_3956.field_17545, inventory, playerEntity.field_6002);
				class_3955 recipe = recipes.get(0);

				class_1799 output = recipe.method_8110();

				if(output.method_7960()){
					continue;
				}


				addRecipe(inputStack, output);

			}
		}

	}

	public static void addRecipe(class_1799 log, class_1799 plank) throws IOException {
		plank.method_7939(4);
		register(log, class_3612.field_15910, 100, 128, plank, TRContent.Dusts.SAW.getStack(3), new class_1799(class_1802.field_8407));
	}

	static void register(class_1799 input1, class_3611 fluid, int ticks, int euPerTick, class_1799... outputs) throws IOException {
		class_2960 sawmill = new class_2960("techreborn:industrial_sawmill");
		generate(sawmill, true, euPerTick, ticks, Collections.singletonList(input1), Arrays.asList(outputs));
	}

	public static File generate(class_2960 type, boolean auto, int power, int time, List<class_1799> inputs, List<class_1799> outputs) throws IOException {
		JsonObject object = new JsonObject();
		object.addProperty("type", type.toString());
		object.addProperty("power", power);
		object.addProperty("time", time);

		{
			JsonArray ingredients = new JsonArray();

			Function<class_1799, JsonObject> toIngredient = stack -> {
				JsonObject jsonObject = new JsonObject();
				if(stack.method_7909() == TRContent.CELL && TRContent.CELL.getFluid(stack) != class_3612.field_15906){
					jsonObject.addProperty("fluid", class_2378.field_11154.method_10221(TRContent.CELL.getFluid(stack)).toString());
					jsonObject.addProperty("holder", "techreborn:cell");
				} else {
					jsonObject.addProperty("item", class_2378.field_11142.method_10221(stack.method_7909()).toString());
					if(stack.method_7947() > 1){
						jsonObject.addProperty("count", stack.method_7947());
					}
					if(stack.method_7909() instanceof ItemDynamicCell){
						//Force it to be an empty cell
						jsonObject.addProperty("nbt", "null");
					}
				}
				return jsonObject;
			};
			inputs.stream().peek(Validate::notNull).forEach(stack -> ingredients.add(toIngredient.apply(stack)));

			object.add("ingredients", ingredients);
		}

		{
			JsonArray results = new JsonArray();

			Function<class_1799, JsonObject> toResult = stack -> {
				JsonObject jsonObject = new JsonObject();
				jsonObject.addProperty("item", class_2378.field_11142.method_10221(stack.method_7909()).toString());
				if(stack.method_7947() > 1){
					jsonObject.addProperty("count", stack.method_7947());
				}
				if(stack.method_7985()){
					jsonObject.add("tag", Dynamic.convert(class_2509.field_11560, JsonOps.INSTANCE, stack.method_7969()));
				}
				return jsonObject;
			};
			outputs.forEach(stack -> results.add(toResult.apply(stack)));

			object.add("results", results);
		}

		String json = new GsonBuilder().setPrettyPrinting().create().toJson(object);

		File dir = new File("C:\\Users\\mark\\Documents\\Modding\\1.14\\TechReborn\\");
		System.out.println(dir.getAbsolutePath());
		File file = null;

		int i = 0;
		while (file == null || file.exists()){
			String name = class_2378.field_11142.method_10221(outputs.get(0).method_7909()).method_12832();
			if(outputs.get(0).method_7909() == TRContent.CELL){
				name = class_2378.field_11154.method_10221(TRContent.CELL.getFluid(outputs.get(0))).method_12832();
				if(name.equals("empty")){
					name = "empty_cell";
				}
			}

			String extraPath = auto ? "/auto/" : "/";

			file = new File(dir, "src/main/resources/data/techreborn/recipes/" + type.method_12832() + extraPath + name + (i == 0 ? "" : "_" + i) + ".json");
			i ++;
		}

		FileUtils.writeStringToFile(file, json, StandardCharsets.UTF_8);

		class_310.method_1551().field_1774.method_1455(file.getAbsolutePath());

		return file;

	}

}
