/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.init.recipes;

import net.minecraft.class_1799;
import net.minecraft.class_1802;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import techreborn.init.TRContent;
import techreborn.items.ItemDynamicCell;
import techreborn.utils.StackWIPHandler;

/**
 * Created by Prospector
 */
public class ScrapboxRecipes extends RecipeMethods {
	public static void init() {
		register(getStack(class_1802.field_8477));
		register(getStack(class_1802.field_8600));
		register(getStack(class_1802.field_8713));
		register(getStack(class_1802.field_8279));
		register(getStack(class_1802.field_8512));
		register(getStack(class_1802.field_8183));
		register(getStack(class_1802.field_8861));
		register(getStack(class_1802.field_8179));
		register(getStack(class_1802.field_8094));
		register(getStack(class_1802.field_8442));
		register(getStack(class_1802.field_8138));
		register(getStack(class_1802.field_8730));
		register(getStack(class_1802.field_8486));
		register(getStack(class_1802.field_8894));
		register(getStack(class_1802.field_8251));
		register(getStack(class_1802.field_8895));
		register(getStack(class_1802.field_8570));
		register(getStack(class_1802.field_8102));
		register(getStack(class_1802.field_8544));
		register(getStack(class_2246.field_10183));
		register(getStack(class_1802.field_8406));
		register(getStack(class_1802.field_8167));
		register(getStack(class_1802.field_8647));
		register(getStack(class_1802.field_8876));
		register(getStack(class_1802.field_8091));
		register(getStack(class_1802.field_8258));
		register(getStack(class_1802.field_8059));
		register(getStack(class_1802.field_8349));
		register(getStack(class_1802.field_8286));
		register(getStack(class_1802.field_8863));
		register(getStack(class_1802.field_8679));
		register(getStack(class_1802.field_8417));
		register(getStack(class_1802.field_8754));
		register(getStack(class_1802.field_8146));
		register(getStack(class_1802.field_8390));
		register(getStack(class_1802.field_8262));
		register(getStack(class_1802.field_8893));
		register(getStack(class_1802.field_8464));
		register(getStack(class_1802.field_8368));
		register(getStack(class_1802.field_8789));
		register(getStack(class_1802.field_8112));
		
//		register(getStack(Items.SKULL, 1, 0));
//		register(getStack(Items.SKULL, 1, 2));
//		register(getStack(Items.SKULL, 1, 4));
		for (int i = 0; i < StackWIPHandler.devHeads.size(); i++)
			register(StackWIPHandler.devHeads.get(i));
		register(getStack(class_1802.field_8601));
		register(getStack(class_1802.field_8276));
		register(getStack(class_1802.field_8045));
		register(getStack(class_1802.field_8388));
		register(getStack(class_1802.field_8836));
		register(getStack(class_1802.field_8662));
		register(getStack(class_1802.field_8868));
		register(getStack(class_1802.field_8287));
		register(getStack(class_1802.field_8606));
		register(getStack(class_1802.field_8428));
		register(getStack(class_1802.field_8621));
		register(getStack(class_1802.field_8378));
		register(getStack(class_1802.field_8529));
		register(getStack(class_1802.field_8407));
		register(getStack(class_1802.field_8479));
		register(getStack(class_2246.field_10424));
		register(getStack(class_1802.field_8680));
		register(getStack(class_1802.field_8777));
		register(getStack(class_1802.field_8511));
		register(getStack(class_1802.field_8788));
		register(getStack(class_1802.field_8674));
		register(getStack(class_1802.field_8176));
		register(getStack(class_1802.field_8448));
		register(getStack(class_1802.field_8175));
		register(getStack(class_1802.field_8725));
		register(getStack(class_1802.field_8054));
		register(getStack(class_1802.field_8245));
		register(getStack(class_1802.field_8073));
		register(getStack(class_1802.field_8279));
		register(getStack(class_1802.field_8463));
		register(getStack(class_1802.field_8397));
		register(getStack(class_1802.field_8815));

		register(ItemDynamicCell.getEmptyCell(1));
		register(getMaterial("water", Type.CELL));
		register(getMaterial("compressedair", Type.CELL));
		register(TRContent.Parts.SAP.getStack());
		register(TRContent.Parts.RUBBER.getStack());
		register(getStack(class_2246.field_10137));
		register(getStack(class_2246.field_10494));
		register(getStack(class_2246.field_10057));
		register(getStack(class_2246.field_10144));
		register(getStack(class_2246.field_10457));
		register(getStack(class_2246.field_10299));
		register(getStack(class_2246.field_10513));
		register(getStack(class_2246.field_10132));
		register(getStack(class_2246.field_10196));
		register(getStack(class_2246.field_10319));
		register(getStack(class_2246.field_10041));
		register(getStack(class_2246.field_10364));
		register(getStack(class_2246.field_10620));
		register(getStack(class_2246.field_10188));
		register(getStack(class_2246.field_10020));
		register(getStack(class_2246.field_10291));
		register(getStack(class_2246.field_10104));
		register(getStack(class_2246.field_9980));
		register(getStack(class_2246.field_10261));
		register(getStack(class_2246.field_10515));
		register(getStack(class_2246.field_10479));
		register(getStack(class_2246.field_10566));
		register(getStack(class_2246.field_10520));
		register(getStack(class_2246.field_10102));
		register(getStack(class_2246.field_10534));
		register(getStack(class_2246.field_10171));
		register(getStack(class_2246.field_10255));
		register(getStack(class_2246.field_10460));
		register(getStack(class_2246.field_10033));
		register(getStack(class_2246.field_10285));
		register(getStack(class_2246.field_10029));
//		register(getStack(Blocks.TALLGRASS, 1, 0));
//		register(getStack(Blocks.TALLGRASS, 1, 1));
//		register(getStack(Blocks.DEADBUSH));
		register(getStack(class_2246.field_10034));
		register(getStack(class_2246.field_10375));
		register(getStack(class_2246.field_10167));
		register(getStack(class_2246.field_10025));
		register(getStack(class_2246.field_10425));
		register(getStack(class_2246.field_10546));
		register(getStack(class_2246.field_10583));
//		register(getStack(Blocks.RED_FLOWER, 1, 0));
//		register(getStack(Blocks.RED_FLOWER, 1, 1));
//		register(getStack(Blocks.RED_FLOWER, 1, 2));
//		register(getStack(Blocks.RED_FLOWER, 1, 3));
//		register(getStack(Blocks.RED_FLOWER, 1, 4));
//		register(getStack(Blocks.RED_FLOWER, 1, 5));
//		register(getStack(Blocks.RED_FLOWER, 1, 6));
//		register(getStack(Blocks.RED_FLOWER, 1, 7));
//		register(getStack(Blocks.RED_FLOWER, 1, 8));
		register(getStack(class_2246.field_10251));
		register(getStack(class_2246.field_10559));
		register(getStack(class_2246.field_10580));
		register(getStack(class_2246.field_10240));
		register(getStack(class_2246.field_10385));
		register(getStack(class_2246.field_10575));
		register(getStack(class_2246.field_10160));
		register(getStack(class_2246.field_10276));
		register(getStack(class_2246.field_10394));
		register(getStack(class_2246.field_10098));
		register(getStack(class_2246.field_10539));
		register(getStack(class_2246.field_10035));
		register(getStack(class_2246.field_10503));
		register(getStack(class_2246.field_9988));

		register(getStack(TRContent.RUBBER_SAPLING));

//		for (String i : ItemDusts.types) {
//			register(ItemDusts.getDustByName(i));
//		}
//		TODO: fix recipe
//		for (String i : ItemNuggets.types) {
//			register(ItemNuggets.getNuggetByName(i));
//		}
//
//		for (String i : ItemGems.types) {
//			register(ItemGems.getGemByName(i));
//		}

//		registerDyable(Items.DYE);
//		registerDyable(Blocks.WOOL);
//		registerDyable(Blocks.CARPET);
//		registerDyable(Blocks.STAINED_GLASS);
//		registerDyable(Blocks.STAINED_GLASS_PANE);
//		registerDyable(Blocks.STAINED_HARDENED_CLAY);
	}

	static void register(class_1799 output) {
		if(output == null || output.method_7960()){
			return;
		}
		//RecipeHandler.addRecipe(Reference.SCRAPBOX_RECIPE, new ScrapboxRecipe(output, 20, 2));
	}


	static void registerDyable(class_2248 block) {
		//registerDyable(Item.getItemFromBlock(block));
	}
}
