/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.utils;

import reborncore.common.crafting.RebornRecipe;
import reborncore.common.registration.RebornRegister;
import reborncore.common.registration.config.ConfigRegistry;
import techreborn.TechReborn;
import techreborn.init.ModRecipes;

import java.util.List;
import java.util.Random;
import net.minecraft.class_1799;
import net.minecraft.class_2315;
import net.minecraft.class_2338;
import net.minecraft.class_2342;
import net.minecraft.class_2347;
import net.minecraft.class_2350;
import net.minecraft.class_2374;
import net.minecraft.class_2601;

@RebornRegister(TechReborn.MOD_ID)
public class BehaviorDispenseScrapbox extends class_2347 {

	@ConfigRegistry(config = "misc", category = "general", key = "DispenserScrapbox", comment = "Dispensers will open scrapboxes")
	public static boolean dispenseScrapboxes = true;

	@Override
	protected class_1799 method_10135(class_2342 source, class_1799 stack) {
		if (dispenseScrapboxes) {
			List<RebornRecipe> scrapboxRecipeList = ModRecipes.SCRAPBOX.getRecipes(source.method_10207());
			int random = new Random().nextInt(scrapboxRecipeList.size());
			class_1799 out = scrapboxRecipeList.get(random).getOutputs().get(0);
			stack.method_7971(1);

			class_2601 blockEntity = source.method_10121();
			class_2350 enumfacing = blockEntity.method_10997().method_8320(new class_2338(source.method_10216(), source.method_10214(), source.method_10215())).method_11654(class_2315.field_10918);
			class_2374 iposition = class_2315.method_10010(source);
			method_10134(source.method_10207(), out, 6, enumfacing, iposition);
		}
		return stack;
	}

}
